'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Demonstration program for the MMBasic for Windows
' It does not do anything useful except demo the various controls
'
' Geoff Graham, October 2015
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Option Explicit
Dim ledsY
Mode 10
Colour RGB(white), RGB(black)
' reference numbers for the controls are defined as constants
Const c_head = 1, c_pmp = 2, sw_pmp = 3, c_flow = 4, tb_flow = 5
Const led_run = 6, led_alarm = 7
Const frm_alarm = 20, nbr_hi = 21, nbr_lo = 22, pb_test =23
Const c_hi = 24, c_lo = 25
Const frm_pump = 30, r_econ = 31, r_norm = 32, r_hi = 33
Const frm_log = 40, cb_enabled = 41, c_fname = 42, tb_fname = 43
Const c_log = 44, cb_flow = 45, cb_pwr = 46, cb_warn = 47
Const cb_alarm = 48, c_bright = 49, sb_bright = 50
' now draw the "Pump Control" display
'CLS
Dim integer x, y, lb, rb, sb, xs, ys, cs, ss
GUI Interrupt TouchDown, TouchUp
' display the heading
Font 2,2 : GUI Caption c_head, "Pump Control", 10, 0
Font 3 : GUI Caption c_pmp, "Pump", 20, 60, , RGB(brown)
' now, define and display the controls
' first
GUI Switch sw_pmp, "ON|OFF", 20, 90, 150, 50, RGB(white),RGB(brown)
CtrlVal(sw_pmp) = 1
' the flow rate display box
Font 3 : GUI Caption c_flow, "Flow Rate", 20, 170,, RGB(brown),0
Font 4 : GUI Displaybox tb_flow, 20, 200, 150, 45
CtrlVal(tb_flow) = "20.1"
' the radio buttons and their frame
Font 3 : GUI Frame frm_pump, "Power", 20, 290, 170, 163,RGB(200,20,255)
GUI Radio r_econ, "Economy", 40, 318, 15, RGB(230, 230, 255)
GUI Radio r_norm, "Normal", 40, 364
GUI Radio r_hi, "High", 40, 408
CtrlVal(r_norm) = 1 ' start with the "normal" button selected
' the alarm frame with two number boxes and a push button switch
Font 3 : GUI Frame frm_alarm, "Alarm", 220, 220, 200, 233,RGB(green)
GUI Caption c_hi, "High:", 232, 260, LT, RGB(yellow)
GUI Numberbox nbr_hi, 318,MM.Info(VPos)-6,90,MM.Info(FontHeight)+12,RGB(yellow),RGB(64,64,64)
GUI Caption c_lo, "Low:", 232, 325, LT, RGB(yellow),0
GUI Numberbox nbr_lo, 318,MM.Info(VPos)-6,90,MM.Info(FontHeight)+12,RGB(yellow),RGB(64,64,64)
GUI Button pb_test, "TEST", 257, 383, 130, 40,RGB(yellow), RGB(red)
CtrlVal(nbr_lo) = 15.7 : CtrlVal(nbr_hi) = 35.5
' draw the two LEDs
Const ledsX = 240, coff = 50 ' define their position
ledsY = 90 : GUI LED led_run, "Running", ledsX, ledsY, 15, RGB(green)
ledsY = ledsY+49 : GUI LED led_alarm, "Alarm", ledsX, ledsY, 15, RGB(red)
CtrlVal(led_run) = 1 ' the switch defaults to on so set the LED on
' the logging frame with check boxes and a text box
Colour RGB(cyan), 0
GUI Frame frm_log, "Log File", 450, 20, 330, 355, RGB(green)
GUI Checkbox cb_enabled, "Logging Enabled", 470, 50, 30, RGB(cyan)
GUI Caption c_fname, "File Name", 470, 105
GUI Textbox tb_fname, 470, 135, 290, 40, RGB(cyan), RGB(64,64,64)
GUI Caption c_log, "Record:", 470, 205, , RGB(cyan), 0
GUI Checkbox cb_flow, "Flow Rate", 500, 245, 25
GUI Checkbox cb_alarm, "Alarms", 500, 285, 25
GUI Checkbox cb_warn, "Warnings", 500, 325, 25
CtrlVal(cb_enabled) = 1
CtrlVal(tb_fname) = "LOGFILE.TXT"
' define and display the spinbox for controlling the backlight
GUI Caption c_bright, "Backlight", 442, 415,,RGB(200,200,255),0
GUI Spinbox sb_bright, MM.Info(HPos) + 8, 400, 200, 50,,,10, 10, 100
CtrlVal(sb_bright) = 50
' All the controls have been defined and displayed. At this point
' the program could do some real work but because this is just a
' demo there is nothing to do. So it just sits in a loop.
Do
Loop
' the interrupt routine for touch down
' using a select case command it has a different process for each
' control
Sub TouchDown
  Local integer mbox
'  print "down"
  Select Case Mouse(REF) ' find out the control touched
  Case cb_enabled ' the enable check box
    If CtrlVal(cb_enabled) Then
      GUI Restore c_fname, tb_fname, c_log, cb_flow, cb_alarm, cb_warn
    Else
      mbox=MsgBox("Are you sure?", "YES","CANCEL")
'      print mbox
      If mbox=1 Then
        GUI Disable c_fname, tb_fname, c_log, cb_flow, cb_alarm, cb_warn
      Else
        CtrlVal(cb_enabled)=1
      EndIf
    EndIf
  Case sb_bright ' the brightness spin box
'    BackLight CtrlVal(sb_bright)
  Case sw_pmp ' the pump on/off switch
    CtrlVal(led_run) = CtrlVal(sw_pmp)
    CtrlVal(tb_flow) = Str$(CtrlVal(sw_pmp) * 20.1)
    CtrlVal(r_norm) = 1
  Case pb_test ' the alarm test button
    CtrlVal(led_alarm) = 1
    GUI beep 250
  Case r_econ ' the economy radio button
    CtrlVal(tb_flow) = Str$(CtrlVal(sw_pmp) * 18.3)
  Case r_norm ' the normal radio button
    CtrlVal(tb_flow) = Str$(CtrlVal(sw_pmp) * 20.1)
  Case r_hi ' the high radio button
    CtrlVal(tb_flow) = Str$(CtrlVal(sw_pmp) * 23.7)
  End Select
End Sub
' interrupt routine when the touch is removed
Sub TouchUp
  Select Case Mouse(LASTREF) ' use the last reference
  Case pb_test ' was it the test button
    CtrlVal(led_alarm) = 0 ' turn off the LED
  End Select
End Sub
'
Function MM.CURSOR( t As integer) As integer
  MM.CURSOR=-1
  If t=1 Then
    readtouch
    MM.CURSOR=lb
    If sprite(x,1)<>10000 Then sprite hide 1
  ElseIf t=2 Then
    If lb Then MM.CURSOR=x
  ElseIf t=3 Then
    If lb Then MM.CURSOR=y
  ElseIf t=4 Then
    MM.CURSOR=lb
  ElseIf t=5 Then
    sprite show 1,x,y,1
  Else
    readtouch
    MM.CURSOR=lb
    sprite show 1,x,y,1
  EndIf
End Function
'
Sub readtouch
 Local s$
  Do
    i2c write 41,1,1,0
    i2c read 41,0,5,s$
    x=Str2bin(uint16,Left$(s$,2),big)
    y=Str2bin(uint16,Mid$(s$,3,2),big)
    lb=Asc(Mid$(s$,5,1))
  Loop Until x>=0 And x<MM.HRes And y>=0 And y< MM.VRes
End Sub
'
Sub mm.beep beeptime As integer
  If beeptime And MM.Info(sound)="OFF" Then play tone 600,600,beeptime
End Sub
